//+------------------------------------------------------------------+
//|                                    MultiPositionExpert_v1.15.mq4 |
//|                                  Copyright  2007, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"


#include <stdlib.mqh>

//---- input parameters
extern string     ExpertName = "MultiPositionExpert_v1.15";

extern string     Data = " Input Data ";
extern bool       StopManageAcc    =   false; // Stop of Manage Account switch(Close All Trades)
extern int        Magic            =       0; // Magic Number ( 0 - for All positions)
extern bool       UsePips          =    true;    
extern double     ProfitTarget     =     100; // Profit target in pips or USD       	
extern double     MaxLoss          =     100; // Maximum total loss in pips or USD     
extern int        CloseMode        =       0; // 0 - Close All orders(open and pending),1-close only open orders 
extern int        AlertMode        =       0; // Alert mode: 0-off,1-on  

int totalPips=0;
double  totalProfits=0;
bool CloseSignal=false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   //CloseSignal=false;
//----
   return(0);
  }

// ---- Scan Open Trades

int ScanTrades(int mode)
{   
   int total = OrdersTotal();
   int numords = 0;
   bool type = false; 
   
   
   
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   
   if (mode == 0) type = OrderType()<=OP_SELLSTOP;
  
   if (mode == 1) type = OrderType()<=OP_SELL;   
   
   if (mode == 2) type = OrderType()>OP_SELL && OrderType()<=OP_SELLSTOP; 
      
      if(Magic==0)
      if(type ) numords++; 
      else
      if(Magic!=0)
      if(type && OrderMagicNumber() == Magic) numords++; 
      
   
   }
   return(numords);
}  
// Closing of Open Orders      
bool OpenOrdClose()
{
    int total=OrdersTotal();
    for (int cnt=0;cnt<total;cnt++)
    { 
    OrderSelect(cnt, SELECT_BY_POS);   
    int mode=OrderType();
    bool res = false; 
    bool condition = false;
    if ( Magic>0 && OrderMagicNumber()==Magic ) condition = true;
    else if ( Magic==0 ) condition = true;
      if (condition && ( mode==OP_BUY || mode==OP_SELL ))
      { 
// - BUY Orders         
         if(mode==OP_BUY)
         {  
         res = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),3,Yellow);
               
            if( !res )
            {
            Print(" BUY: OrderClose failed with error #",GetLastError());
            Print(" Ticket=",OrderTicket());
            Sleep(3000);
            }
         break;
         }
         else     
// - SELL Orders          
         if( mode == OP_SELL)
         {
         res = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),3,White);
                 
            if( !res )
            {
            Print(" SELL: OrderClose failed with error #",GetLastError());
            Print(" Ticket=",OrderTicket());
            Sleep(3000);
            }
         break;    
         }  
      }                  
   }
   return(res);
}

void TotalProfit()
{
   int total=OrdersTotal();
   totalPips = 0;
   totalProfits = 0;
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();
   bool condition = false;
   if ( Magic>0 && OrderMagicNumber()==Magic ) condition = true;
   else if ( Magic==0 ) condition = true;   
      if (condition)
      {      
         switch (mode)
         {
         case OP_BUY:
            totalPips += MathRound((MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice())/MarketInfo(OrderSymbol(),MODE_POINT));
            totalProfits += OrderProfit();
            break;
            
         case OP_SELL:
            totalPips += MathRound((OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK))/MarketInfo(OrderSymbol(),MODE_POINT));
            totalProfits += OrderProfit();
            break;
         }
      }            
	}
}

void ChartComment()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";

   sComment = sp;
   sComment = sComment+"Orders: Open= "+ScanTrades(1)+" Pending= "+ScanTrades(2)+" All= "+ScanTrades(0)+NL;
   sComment = sComment+"Current Profit(pips)= " + totalPips + NL;
   sComment = sComment+"Current Profit(USD) = " + DoubleToStr(totalProfits,2) + NL; 
   sComment = sComment+sp;
  
   Comment(sComment);
}

bool PendOrdDel()
{
   for (int i=0; i<OrdersTotal(); i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
   bool condition = false;
      if ( Magic>0 && OrderMagicNumber()==Magic ) condition = true;
      else if ( Magic==0 ) condition = true;
       
      if ( condition && OrderType() > OP_SELL)
      {     
      bool result = OrderDelete(OrderTicket());
         
      if(!result) 
      Print("OrderDelete failed with error #",GetLastError());
      }
   }      
   return(result);
}    	   
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(CloseMode==0 && ScanTrades(0)==0) CloseSignal=false;
   if(CloseMode==1 && ScanTrades(1)==0) CloseSignal=false;
   
   RefreshRates();
   TotalProfit();
   ChartComment();
    
   if (!StopManageAcc)
   {
      if(ScanTrades(1) > 0 && !CloseSignal && (ProfitTarget>0 || MaxLoss>0))
      {
         if(UsePips)
         {
         if(ProfitTarget > 0 && totalPips>=ProfitTarget) CloseSignal=true;    
         if(MaxLoss > 0 && totalPips <= -MaxLoss) CloseSignal=true; 
         }
         else
         {
         if(ProfitTarget > 0 && totalProfits>=ProfitTarget) CloseSignal=true;
         if(MaxLoss > 0 && totalProfits <= -MaxLoss) CloseSignal=true;
         }        
      }   
   }
   else 
   { if (ScanTrades(0) > 0) CloseSignal=true;}    
      
   bool OpenResult = false, PendResult=false;
   if (CloseSignal)
   {
   OpenResult = OpenOrdClose();
      if( CloseMode==0 ) 
      {
      PendResult = PendOrdDel();
      if (!PendResult) RefreshRates();
      }
   if( AlertMode > 0 && OpenResult && ScanTrades(1)==0) Alert(ExpertName,": Orders are closed!");   
   }       
 return(0);
}//int start
//+------------------------------------------------------------------+





